/** Depot4 (c) J. Lampe 1997-2003
AccTab.java

This table maintains a set of Strings and allows a rapid
check whether a given String is contained or not.

In the generator, it serves for checking names against keywords.

	* @author	Juergen Lampe
	* @version 1.9.2
	* Date:		24.04.2003
*/

package Dp4;

import java.io.IOException;
import java.io.RandomAccessFile;
import java.util.Hashtable;
import java.util.Enumeration;

public class AccTab {

	/** Hashtable could be replaced by HashMap. This would also 
	* avoid the need for <code>dummy</code> as it allows null items.*/
  private final Hashtable hashtable= new Hashtable();
  private static final Object dummy= new Object();
	
  private final char[] ac= new char[256];
 
	//--------------------------------- Insert ------------------------------
	public void Insert(String s){
	  if (!hashtable.containsKey(s)) {
			hashtable.put(s, dummy);
		}
	}
	public void addString(String s){
	  if (!hashtable.containsKey(s)) {
			hashtable.put(s, dummy);
		}
	}
	
	//--------------------------------- Check -------------------------------
	public boolean Check(String s){
    return hashtable.containsKey(s);
	} 
	public boolean contains(String s){
    return hashtable.containsKey(s);
	} 
	
	//--------------------------------- List ----------------------------------
	public void List(){
	  for (Enumeration e= hashtable.keys(); e.hasMoreElements();) {
	    Dp4.OP.WrStr("'"+e.nextElement().toString()+"'\n");
	  }
	} 
	public void list(){
	  for (Enumeration e= hashtable.keys(); e.hasMoreElements();) {
	    Dp4.OP.WrStr("'"+e.nextElement().toString()+"'\n");
	  }
	} 
	
	//--------------------------------- Add ----------------------------------
	/** Adds all the strings in the file named filename */
	public void addFromFile(String filename){
		Add(filename);
	}
	
	public void Add(String filename){
	  char ch;
	  int i;
	  RandomAccessFile fn;
	  try { 
			fn= new RandomAccessFile(filename, "r"); 
			fn.seek(0);}
	  catch (Exception ioex) { 
			return; 
		}
	  for (;;){
	    i= 0;
	    for (;;) {
	      try { 
					int c= fn.read();
	        if (c==-1) 
						ch= '\000'; 
					else 
						ch= (char)c;
				}
	      catch (IOException ioex) { 
					ch= '\000'; 
				}
	      if (ch>' ') ac[i++]= ch; 
				else break;
	    }  
	    if (i!=0)
				Insert(String.copyValueOf(ac, 0, i));
	    if (ch=='\000') 
				break;
	  }
	}
	 
	//--------------------------------- Init ----------------------------------
	/** Returns a new instance of this class.
	* (Requested by the generator interface.)
	*/
	public static AccTab Init(){
	  return new AccTab();
	} 
	
	/** Constructor */ 
	public AccTab(){}
} 
