/** Depot4 (c) J. Lampe 1996-2003
    Base.java
		
		Definition of global constants.
    
    * @author	Juergen Lampe
    * @version 1.9.2
    * Date:   26.02.2003
    */
    
package Dp4;

import java.util.BitSet;

public class Base {

	public static final char noChar      = '\037',// def. "no character" input symbols
	                         abbrChr     = '$',		// abbrevation char
	                         EOL         = '\n';	// used to map diff. end of line chars on
	public static final int  SymLen      = 64, 		// max. length for Ml4's SYM type
	                         MaxComments = 4;			// max. number of comment type definitions
													 
	public static final BitSet LogLevel  = new BitSet(16);  // def. of log types
	
	/** Log bits:
	<dl>
	<dt>0<dd>reserved
	<dt>1<dd>Comment definitions
	<dt>2<dd>Module initializations
	<dt>3<dd>Module warnings
	<dt>4<dd>Globals (not active yet)
	<dt>5<dd>reserved
	<dt>6<dd>Warnings (in IDE only)
	<dt>7<dd>Timing (in IDE only)
	<dt>8<dd>reserved
	<dt>9<dd>Verbose compiling
	<dt>10<dd>Lexer settings (decide lower/upper case, lexem exclusion lists, ...)
	<dt>11<dd>Module load exceptions
	<dt>12<dd>Module loading
	<dt>13<dd>Exception stacks
	<dt>14<dd>free for use
	<dt>15<dd>free for use
	</dl>	
	*/
}
