/** Depot4 (c) J. Lampe 1997-2003
BrPtObs.java

		Branch point observer.
		Subclasses can be used to intercept the basic operations on 
		branch points.
		Can be applied to get nested invocations due to the definition
		sequence of the observers.
		Currently used only for analysis (@see Count).
		
	* @author	Juergen Lampe
	* @version 1.9.2
	* Date:		24.04.2003
  */

package Dp4;

public class BrPtObs {
  protected BrPtObs nxt= null;
  
  //----------------------------- ND ------------------------------
  public void ND(Dp4.Prs0 P){
      if (nxt!=null) nxt.ND(P);
  }
  //----------------------------- BT ------------------------------
  public void BT(Dp4.Prs0 P){
      if (nxt!=null) nxt.BT(P);
  }
  //----------------------------- DB ------------------------------
  public void DB(Dp4.Prs0 P){
      if (nxt!=null) nxt.DB(P);
  }
  //----------------------------- SB ------------------------------
  public void SB(Dp4.Prs0 P){
      if (nxt!=null) nxt.SB(P);
  }
    
	public BrPtObs(){}
} 
