/** Depot4 (c) J. Lampe 1996-2003
    ClassNetLoader.java
		
		A class loader for loading/reloading 'remote' classes from an URL.
    
    * @author  Juergen Lampe
    * @version 1.9.2
    * Date:   19.03.2003
    */
    
package Dp4;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.MalformedURLException;
import java.net.URL;

class ClassNetLoader extends ClassLoader{

	private static ClassNetLoader cnl= null;

//---------------------------- loadClass1 ------------------------------
  public Class loadClass1(String name, boolean resolve)
    throws ClassNotFoundException {
    Class newClass= null;
    try {
      byte[] buf = bytesForClass(name);
      newClass = defineClass(null, buf, 0, buf.length);
      if (resolve)
        try {resolveClass(newClass);}
        catch (VerifyError v){
					throw new ClassNotFoundException(v.toString());
				}
      return newClass;
    } catch (Exception e) {
			throw new ClassNotFoundException(e.toString());
		}
  }
//----------------------------- loadClass ------------------------------
  public Class loadClass(String name, boolean resolve)
    throws ClassNotFoundException {
      return findSystemClass(name);
  }
//---------------------------- bytesForClass ---------------------------
  protected byte[] bytesForClass(String name) 
    throws ClassNotFoundException, IOException {
    InputStream in= streamFor(name);
    int noB= in.available(), cnt= 0;
    if (noB==0) throw new ClassNotFoundException(name);
    ByteArrayOutputStream buf= new ByteArrayOutputStream(noB);
    byte [] iob= new byte[512];
    while ((cnt= in.read(iob))!=-1) { 
			buf.write(iob, 0, cnt);
		}
    iob= buf.toByteArray();
    in.close(); 
		buf.close();
    return iob;
  }
//----------------------------- streamFor ------------------------------
  protected InputStream streamFor(String name)throws ClassNotFoundException {
    InputStream in;
    URL url= null;
    String fname= name;
    try { 
			url= new URL(fname+".class"); 
		}
    catch (MalformedURLException e) {
       throw new ClassNotFoundException(e.toString());}
    try {
      in= url.openStream();
    } catch (IOException e) { 
     throw new ClassNotFoundException(e.toString());
		}
    return in;
  }
//----------------------------- forName ------------------------------
  public static Class forName(String name) throws ClassNotFoundException {
		if (cnl==null) {
			cnl= new ClassNetLoader(name.getClass().getClassLoader());
		}
		return cnl.loadClass1(name, true);
	}
	
  public static Class reForName(String name) throws ClassNotFoundException {
		cnl= new ClassNetLoader(name.getClass().getClassLoader());
		return cnl.loadClass1(name, true);
	}

	/** Constructor */
	protected ClassNetLoader(){}

	protected ClassNetLoader(ClassLoader parent) {
		super(parent);
	}
}
