/** Depot4 (c) J. Lampe 1996-2010
    ClassReloader.java
		
		This loader is applied for reloading "corrected" classes into the same VM.
    
    * @author  Juergen Lampe
    * @version  1.9.4
    * Date:   19.03.2003
    */

package Dp4;

import java.io.ByteArrayOutputStream;
import java.io.FileInputStream;
import java.io.IOException;

class ClassReloader extends ClassLoader{

//---------------------------- loadClass1 ------------------------------
  Class loadClass1(String name, boolean resolve)
    throws ClassNotFoundException {
    Class newClass= null;
    try {
      byte[] buf = bytesForClass(name);
      newClass = defineClass(null, buf, 0, buf.length);
      if (resolve) 
        try {resolveClass(newClass);}
        catch (VerifyError v){throw new ClassNotFoundException(v.toString());}
        catch (ClassFormatError e) {throw new ClassFormatError();}
        catch (Exception e) {
          throw new ClassNotFoundException(e.toString());}
      return newClass;
    } catch (Exception e) {
     throw new ClassNotFoundException(e.toString());}
  }
//----------------------------- loadClass ------------------------------
  public Class loadClass(String name, boolean resolve)
    throws ClassNotFoundException {
      return findSystemClass(name);
  }
//---------------------------- bytesForClass ---------------------------
  public byte[] bytesForClass(String name) 
    throws ClassNotFoundException, IOException {
    FileInputStream in= streamFor(name);
    int noB= in.available(), cnt= 0;
    if (noB==0) throw new ClassNotFoundException(name);
    ByteArrayOutputStream buf= new ByteArrayOutputStream(noB);
    byte [] iob= new byte[512];
    while ((cnt= in.read(iob))!=-1) { 
			buf.write(iob, 0, cnt);
		}
    iob= buf.toByteArray();
    in.close(); 
		buf.close();
    return iob;
  }
//----------------------------- streamFor ------------------------------
  static FileInputStream streamFor(String name)throws ClassNotFoundException {
    FileInputStream in;
    String fname= name.replace('.', '/');
    try {
      in= new FileInputStream(fname+".class"); // throws FileNotFoundException 
    } catch (IOException e) { // Dp4.OP.WrStr(e.toString()+"\n");
     throw new ClassNotFoundException(e.toString());}
      return in;
  }
//----------------------------- forName ------------------------------
	public static Class forName(String name)
		throws ClassNotFoundException {
		Class cl;
		try {
			cl= (new ClassReloader()).loadClass1(name, true);
		} catch (ClassFormatError e) {
			throw new ClassNotFoundException(e.toString());
		}
		return cl;
	}
	
	/** Constructor */
	protected ClassReloader(){}
}