/**
 * 
 */
package Dp4;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 * @author lampe
 *
 */
public class CommonsLogStubFactory implements LogStubFactory {

	public LogStub getLog(String s) {
		return new CommonsLogStub(LogFactory.getLog(s));
	}
	
	public class CommonsLogStub extends LogStub {
		
		private final Log log;

		public CommonsLogStub(Log log) {
			this.log= log;
		}

		/* (non-Javadoc)
		 * @see Dp4.LogStub#isLogEnabled(int)
		 */
		public boolean isLogEnabled(int severity) {
			if (severity>3) {
				severity= 3;
			}
			switch (severity) {
	    		case 0: return log.isInfoEnabled();
	    		case 1: return log.isWarnEnabled();
	    		case 2: return log.isErrorEnabled();
	    		case 3: return log.isFatalEnabled();
	    		case -1: return log.isDebugEnabled();
	    		default: return log.isTraceEnabled();
			}
		}

		/* (non-Javadoc)
		 * @see Dp4.LogStub#log(int, java.lang.String)
		 */
		public void log(int severity, String msg) {
			if (severity>3) {
				severity= 3;
			}
			switch (severity) {
	    		case 0: log.info(msg); break;
	    		case 1: log.warn(msg); break;
	    		case 2: log.error(msg);break;
	    		case 3: log.fatal(msg); break;
	    		case -1: log.debug(msg); break;
	    		default: log.trace(msg); break;
			}
		}

		/* (non-Javadoc)
		 * @see Dp4.LogStub#log(int, java.lang.String, java.lang.Throwable)
		 */
		public void log(int severity, String msg, Throwable ex) {
			if (severity>3) {
				severity= 3;
			}
			switch (severity) {
	    		case 0: log.info(msg, ex); break;
	    		case 1: log.warn(msg, ex); break;
	    		case 2: log.error(msg, ex);break;
	    		case 3: log.fatal(msg, ex); break;
	    		case -1: log.debug(msg, ex); break;
	    		default: log.trace(msg, ex); break;
			}
		}
	}

}
