package Dp4;

import java.io.ByteArrayOutputStream;
import java.io.PrintWriter;
import java.io.OutputStream;

import com.sun.tools.javac.Main;

/** Wrapper for SUN's Java compiler as shipped with from SDK 1.4.1 on.
 *
 * @author Juergen Lampe
 * @version 1.9.2
 * Date: 03.03.2003
 * @since JDK 1.4.1
 */

public class Default14Compiler implements HostCompiler{

	/** Returns the name of the compiler as used in a command line interface,
	 * e.g. "javac" for SUN's compiler.
	 * @return the compiler name
	 */
	public String getCompilerName(){
		return "javac";
	}
	
	/** Invokes the compiler to compile a class file.
	 *
	 * @param args classpath, working directory, or other settings, and the classfile name
	 * @return the compiler output
	 */
	public String compile(String[] args){
		final OutputStream b= new ByteArrayOutputStream(128);
		// Invoke SUN's java compiler:
		final int exitCode= Main.compile(args, new PrintWriter(b, true));
		return b.toString()+(exitCode==0?"done":"error(s)")+"\n";
	}
}

