package Dp4;

import java.io.ByteArrayOutputStream;
import java.io.OutputStream;
import java.io.PrintStream;

import sun.tools.javac.Main;

/** Wrapper for SUN's Java compiler as shipped with the JDK.
 * This is the compiler for pre 1.4.1 JDKs.
 * 
 * @author Juergen Lampe
 * @version 1.9.2
 * Date: 03.03.2003
 */

public class DefaultCompiler implements HostCompiler{

	/** Returns the name of the compiler as used in a command line interface,
	 * e.g. "javac" for SUN's compiler.
	 * @return the compiler name
	 */
	public String getCompilerName(){
		return "javac";
	}
	
	/** Invokes the compiler to compile a class file.
	 *
	 * @param args classpath, working directory, or other settings, and the classfile name
	 * @return the compiler output
	 */
	public String compile(String[] args){
		final OutputStream b= new ByteArrayOutputStream(128);
		// Invoke SUN's java compiler:
		(new Main(new PrintStream(b), "javac")).compile(args);
		return b.toString();
	}
}

