package Dp4;

/** Interface for host language compiler wrapper.
 * 
 * @author Juergen Lampe
 * @version 1.9.2
 * Date: 04.03.2003
 */

public interface HostCompiler {

	/** Returns the name of the compiler as used in a command line interface,
	 * e.g. "javac" for SUN's compiler. (Used in log only.)
	 * @return the compiler name
	 */
	public String getCompilerName();

	/** Invokes the compiler to compile a class file.
	 *
	 * @param args classpath, working directory, or other settings, and the classfile name
	 * @return the compiler output
	 */
	public String compile(String[] args);

}
