/** Depot4 (c) J. Lampe 1996-2010
    ListNT.java

 		Utility class:
		Lists all currently known nonterminal symbols.
    
    @author  Juergen Lampe
    @version  1.9.4
    Date:   24.04.2003
    */
    
package Dp4;

public class ListNT extends enumProcT{

  static ListNT listp= new ListNT();
	
	public ListNT(){}
	
  public void process (Translator tr, NonTermT t){
    if (t.name.charAt(0)=='<'){
			// skip dummy entries
			return;
    }
    OP.WrStr(t.name+" from "
      +((!t.name.equals(t.eqname))?t.eqname+":":"")
      +t.impname
			+" ("+t.getCurrentName()+")"
    +"\n");
  }
	
	/** Get header String.
	* May be overwritten in subclasses 
	*/
	protected String getHeader() {
		return "+++++++++++++++++++++++++++++++++\n";
	}
	
	/** Interface method */
  public static void list(Translator translator) {
    OP.WrStr(listp.getHeader());
		if (translator!=null) {
    	translator.enumerateNT(listp);
		}
  }
	
	/** Interface method */
  public static void list() {
    list(Translator.getCurrentTranslator());
  }
}
