/** Depot4 (c) J. Lampe 1996-2003
NTcall.java

    * @author  Juergen Lampe
    * @version 1.9.2
    * Date:   26.2.2003
		
		Abstract base (interface) class for invoking a production rule (nonterminal, NT)
		which is dynamically defined by its name String only.
 		(Ignoring any generated target, thus being the outermost level of invocation usually.)
*/
package Dp4;
 
public class NTcall{
	protected static NTcall currentNTcall= new NTcall();

	/** Subclass installs itself by calling this.
	 * @param ntCall the class to install as a handler
	 */
	protected static void install(NTcall ntCall) {
		currentNTcall= ntCall;
	}

	/** Subclasses must overwrite this method.
	 * @param P the input parser to be apllied
	 * @param name the root production's name
	 */
	protected void callNTbyName (Prs P, String name){
		throw new RuntimeException("NTcall not implementet");
	}

	/** Invoke a production known by its name
	 * @param P the input parser to be apllied (instance of Prs required)
	 * @param name the root NT name
	 */
	public static void callNT(Prs0 P, String name) {
		currentNTcall.callNTbyName((Prs)P, name);
	}
}
