/** Depot4 (c) J. Lampe 1996-2010
NTprocMonT.java

		Functionality for enabling and disabling nonterminal based monitoring.
		
	* @author	Juergen Lampe
	* @version  1.9.4
	* Date:		24.04.2003
  */

package Dp4;

public class NTprocMonT extends NTprocedure {

    private static int noMonPropertyKey= Translator.getPropertyKey("NTprocMonT.noMon");
    private static int monAllprocPropertyKey= Translator.getPropertyKey("NTprocMonT.monAllproc");

    protected NTprocMonT nxt= null;

    public trgts parse(NonTermT nt, Prs P) {
        if (isNotMonitoring(P.getTranslator())) {
            return ((NonTerm)nt).monP.parse(nt, P);
        }
        if (this.nxt == null) {
            return ((NonTerm)nt).monP.parse(nt, P);
        } else {
            return nxt.parse(nt, P);
        }
    }

    public static void All(Translator translator){
        if (getMonAllProc(translator)!=null) {
            translator.enumerateNT(new setMon());
        }
    }

    public static void No(Translator translator){
        translator.enumerateNT(new clrMon());
    }

    public void add(Translator translator, NTprocMonT mp){
        NTprocMonT h= this;
        if (getMonAllProc(translator)==null) setMonAllProc(translator, mp);
        else {
            while (h.nxt!=null) h= h.nxt;
            h.nxt= mp;
        }
    }

    public static void set(Translator translator, NTprocMonT mp){
        setNotMonitoring(translator, mp==null);
        NTprocMonT h= (NTprocMonT)getMonAllProc(translator);
        if (getMonAllProc(translator)==null||mp==null)
            setMonAllProc(translator, mp);
        else {
            while (h.nxt!=null)
                h= h.nxt;
            h.nxt= mp;
        }
    }

    public static void NT(Translator translator, String s){
        if (s.charAt(0)=='*') {
            setNotMonitoring(translator, false);
        } else {
            NonTerm t= translator.registNT(s);
            if (t.mon)
                t.P= getMonAllProc(translator);
            else {
                t.mon= true;
                t.monP= t.P;
                t.P= getMonAllProc(translator);
            }
        }
    }

    public static void noNT(Translator translator, String s){
        if (s.charAt(0)=='*') {
            setNotMonitoring(translator, true);
        } else {
            NonTerm t= translator.registNT(s);
            if (t.mon) {
                t.mon= false;
                t.P= t.monP;
            }
        }
    }
    public static void setNo(Translator translator) {
        setNotMonitoring(translator, true);
    }

    public static void set(Translator translator){
        setNotMonitoring(translator, false);
    }

    public NTprocMonT(){
    }

    static NTprocedure getMonAllProc(Translator translator) {
		NTprocedure monAllproc=	(NTprocedure)translator.getValueFor(monAllprocPropertyKey);
		return monAllproc;
	}
	
	static void setMonAllProc(Translator translator, NTprocedure monAllproc) {
		translator.setValueFor(monAllprocPropertyKey, monAllproc);
	}
	
	static boolean isNotMonitoring(Translator translator) {
		Boolean is=	(Boolean)translator.getValueFor(noMonPropertyKey);
		return (is==null) || is.booleanValue();
	}
	
	static void setNotMonitoring(Translator translator, boolean b) {
		translator.setValueFor(noMonPropertyKey, b?Boolean.TRUE:Boolean.FALSE);
	}
}

//--------------------------------------------------------------------------------------- 
class setMon extends enumProcT{

    public void process(Translator translator, NonTermT nt){
        NonTerm t= (NonTerm)nt;
        if (t.mon) {
            t.P= NTprocMonT.getMonAllProc(translator);
        } else {
            t.mon= true;
            t.monP= t.P;
            t.P= NTprocMonT.getMonAllProc(translator);
        }
    }
}
//--------------------------------------------------------------------------------------- 

//--------------------------------------------------------------------------------------- 
class clrMon extends enumProcT{

    public void process(Translator translator, NonTermT nt){
        NonTerm t= (NonTerm)nt;
        if (t.mon) {
            t.mon= false;
            t.P= t.monP;
        }
    }
}
//--------------------------------------------------------------------------------------- 
