/** Depot4 (c) J. Lampe 1996-2003
    Source.java
    
    * @author  Juergen Lampe
    * @version 1.9.2
    * Date:   05.03.2003
    */
    
package Dp4;
  
public class Source{
 	protected Token startToken= null;
	protected Token currentToken= null;

	public void Reset() {
		currentToken= startToken;
		if (currentToken!=null) {
			currentToken.Reset();
			currentToken.open= true;
		}
	}
	
	public SourcePos GetPos() {
		SourcePos t= null;
		if (currentToken!=null) {
			t= (SourcePos)currentToken.GetPos();
			t.tkn= currentToken;
		}
		return t;
	}

	public void SetPos(SourcePos t) {
		if (t==null)
			currentToken= null;
		else {
			currentToken= t.tkn;
			if (!currentToken.open) {
				currentToken.Reset();
				currentToken.open= true;
			}
			currentToken.SetPos(t);
		}
	}
	
	public void LogPos() {
		Dp4.OP.WrStr(getPositionString());
	}

	public String getPositionString(){
		String result = " end of source";
		if (currentToken!=null){
			result= currentToken.getPositionString();
		}
		return result;
	}

	public static Source concTkn(Source source, Token token) {
		if (source==null)
			source= new Source();
		if (source.startToken==null)
			source.startToken= token;
		else { 
			if (source.currentToken==null) {
				source.currentToken= source.startToken;
		    while (source.currentToken.nxt!=null)
					source.currentToken= source.currentToken.nxt;
			}
			source.currentToken.nxt= token;
		}
		source.currentToken= token;
		while (source.currentToken.nxt!=null)
			source.currentToken= source.currentToken.nxt;
		return source;
	}
 
	public static Source appendSource(Source source, Source source2) {
		if (source2!=null && source2.startToken!=null)
			concTkn(source, source2.startToken);
		return source;
	}
	
	public Token NxtTkn() {
		Token t= null;
		if (currentToken!=null)
			t= currentToken.nxt;
		if (t!=null) 
			currentToken= t;
		return t;
	}
	
	public char NxtChr () { 
		char C;
		Token h;
		h= currentToken;
		if (h==null) 
			return '\000';
		for (;;) { 
			C= h.NxtChr();
			if (C=='\000') { 
				h.Close(); 
				h.open= false;
				h= NxtTkn();
				if (h==null) { 
					return '\000';
				}
				else { 
					h.Reset(); 
					h.open= true;
				}
			}
			else
				return C;
		}
	}
	
	public boolean EOS() { 
		return currentToken==null;
	}
	
	public Source () {}
}
