/** Depot4 (c) J. Lampe 1996-2003
 */
package Dp4;

/** Interface for output streams.
 * 
 * @author Juergen Lampe
 * @version 1.9.2
 * Date: Apr 24, 2003
 */

public interface Stream {

	/** Opens the stream.
	 * Only open stream can be written to.
	 */
	void Open();

	/** Closes the stream, i.e. no subsequent writes are permitted.*/
	void Close();

	/** Writes a single character to the stream */
	void Write(char c);

	/** Writes a string to the stream. */
	void WriteString(String s);

	/** Writes a 'newline' to the stream.
	 * The meaning of 'newline' is defined by the actual stream.
	 */
	void WriteLn();

	/** For system internal use */
	void copy2Strm(SourcePos beg, SourcePos end);
}
