/** Depot4 (c) J. Lampe 1996-2010
    Streams.java

    * @author  Juergen Lampe
    * @version  1.9.4
    * $Date: 2010/05/11 $
    */
package Dp4;

public abstract class Streams implements OutStream {
  String newLine= "\n";

  public String sn;
  public boolean eos;
  public int beg= 0, end= -1;

  public void Open(){}
  public void Close(){}

  /** Subclasses must overwrite this method only to do the actual writing on the
   * stream.
   * @param s the String to write on the Stream
   */
  public abstract void WriteStr(String s);
	
  public void Write(char c){
	  if ('\n'==c) 
		  WriteLn();
	  else 
		  WriteStr(String.valueOf(c));
  }

  public void WriteString(String s){
	  int f= 0, t, l= s.length();
	  do {
		  t= s.indexOf('\n', f);
		  if (t==-1) {
			  WriteStr(s.substring(f)); 
			  return;
		  }
		  WriteStr(s.substring(f, t));
		  WriteLn();
		  f= ++t;
	  } while (f<l);
  }

  public void WriteLn() { 
	  WriteStr(newLine);
  }

	//-------------------------------------------------------
	// Utility methods
	//-------------------------------------------------------

    /** Writes the target to the stream */
    public static void Tar2Strm(tNode Nd, OutStream S){
    	StreamTrg.Tar2Strm(Nd, S);
    }

	/** Constructs a Source object from a Stream */
    public static Source StrmSrc(InStream S) {
    	return StrmToken.StrmSrc(S);
    }
  
    /* (non-Javadoc)
     * @see Dp4.OutStream#copy2Strm(Dp4.SourcePos, Dp4.SourcePos)
     */
    public void copy2Strm(SourcePos beg, SourcePos end){
    	int bpos, epos, r, save; 
    	boolean sb;
    	char currChar;
    	InStream inStream;
    	Token tk= beg.tkn;
    	bpos= ((TokenPos)beg).pos-1;
    	for (;;) {
    		if (tk!=end.tkn){ 
    			epos= Integer.MAX_VALUE;
    		} else {
    			epos= ((TokenPos)end).pos;
    		}
    		if (tk instanceof StrmToken){
    			inStream= ((StrmToken)tk).str;
    			sb= tk.open;
    			if (!sb) {
    				inStream.Open();
    			}
    			save= inStream.Get(); 
    			inStream.Set(bpos); 
    			for (;;){
    				currChar= inStream.Read(); 
    				r= inStream.Get();
    				if (r>=epos||currChar=='\000') {
    					break;
    				}
    				Write(currChar);
    			}
    			inStream.Set(save);
    			if (!sb) {
    				inStream.Close();
    			}
    		}
    		if (tk!=end.tkn) {
    			tk= tk.nxt; 
    			bpos= 0;
    		}else {
    			break;
    		}
    		if (tk==null) {
    			OP.ERROR(30); 
    			break;
    		}
    	}
    }

}
