/** Depot4 (c) J. Lampe 1996-2010
    StrmToken.java
    
    * @author  J. Lampe
    * @version  1.9.4
    * Date:   05.03.2003
    */
    
package Dp4;

public class StrmToken extends Token {

  public InStream str= null;
	
	// reduce memory requirements
	private static final int CACHE_LENGTH= 32;
	private TokenPos cachedTokenPos[]= new TokenPos[CACHE_LENGTH];

  public static Source StrmSrc( InStream S) {
    return Source.concTkn(null, new StrmToken(S));
  }
	
  public void Reset(){
    str.Open();
  }
	
  public SourcePosDef GetPos(){
    int i= str.Get();
		int ci= i%CACHE_LENGTH;
		TokenPos tokenPos= cachedTokenPos[ci];
		if (tokenPos!=null && tokenPos.pos==i) {
			return tokenPos;
		} else {	
	    tokenPos= new TokenPos();
	    tokenPos.pos= i;
			cachedTokenPos[ci]= tokenPos;
	    return tokenPos;
		}
  }
	
  public void SetPos( SourcePosDef p) {
    TokenPos tokenPos= (TokenPos)p;
    str.Set(tokenPos.pos);
  }
	
  public void LogPos(){ 
    Dp4.OP.WrStr(getPositionString());
  }

	public String getPositionString(){
		return "\""+((Dp4.InStream)str).Description()+"\" pos "+str.Get()+" ";
	}

  public char NxtChr(){
		final char c = str.Read();
		return c;
  }
	
  public StrmToken(InStream S) { 
		str= S;
  }

  public StrmToken(){
	}
	
}
