/** Depot4 (c) J. Lampe 1996-2010
id.java

	Default identifier implementation. Accepts identifiers starting
	with a letter followed by a number of letters or digits.
	Up to MAX_SIG characters are significant.

 * @author   Juergen Lampe
 * @version  1.9.4
 * $Date: 2010/05/19 $
 */

package Dp4;

import java.util.Stack;

public final class id extends NTprocedure {

	private static int exclusionListPropertyKey= Translator.getPropertyKey("id.XList");
	private static int exclusionListStackPropertyKey= Translator.getPropertyKey("identX.XListStack");

	private Translator y_translator;

	/**Constructor */
	public id(){
	}

	//------------------------ id ------------------------
	private trgts y_p_id(NonTermT y_NT, Prs y_Prs){
		String y_SYM;
		char C;
		StringBuffer sb= new StringBuffer();
		trgts y_0tg= new trgts();
		NonTermT y_yNT= y_translator.curNT; y_translator.curNT= y_NT;
		y_Prs.Skip();
		C= y_Prs.AC();
		y_Prs.A= Character.isLetter(C);
		if (y_Prs.A) {
			y_Prs.acc(); 
			sb.append(C);
			while ( Character.isLetterOrDigit(C= y_Prs.AC())) {
				y_Prs.acc();
				sb.append(C);
			}
		}
		if (y_Prs.A) {
			y_SYM= sb.toString();
			if (!y_translator.isCap()) 
				y_0tg.trg0= y_SYM.toUpperCase(); 
			else 
				y_0tg.trg0= y_SYM;
			if (getLexemExclusionList(y_translator).contains(y_0tg.trg0)) {
				y_Prs.A= false;
			} else { 
				y_0tg.trg1= Chars.appStr(null, sb.toString());
			}
		}
		y_translator.curNT= y_yNT;
		return y_0tg;
	}

	public void init(Translator translator){
		id y_ntp_= new id();
		translator.installNT("id", y_ntp_);
		translator.installNT("ident", y_ntp_);
		y_ntp_.y_translator= translator;
	}

	public trgts parse(NonTermT NT, Prs Prs){
		return y_p_id(NT, Prs);
	}

	private static AccTab getLexemExclusionList(Translator translator) {
		AccTab exclusionList=	(AccTab)translator.getValueFor(exclusionListPropertyKey);
		if (exclusionList==null) {
			exclusionList= new AccTab();
			translator.setValueFor(exclusionListPropertyKey, exclusionList);
		}
		return exclusionList;
	}

	public static AccTab getLexemExclusionList() {
		return getLexemExclusionList(Translator.getCurrentTranslator());
	}

	public static void addToLexemExclusionList(String lexem) {
		getLexemExclusionList(Translator.getCurrentTranslator()).addString(lexem);
	}

	public static void setLexemExclusionListFile(String filename) {
		Translator translator= Translator.getCurrentTranslator();
		AccTab exclusionList=	new AccTab();
		exclusionList.addFromFile(filename);
		translator.setValueFor(exclusionListPropertyKey, exclusionList);
		if (Base.LogLevel.get(10)) 
			OP.WrStr(Messages.systemMessages[7]+Messages.systemMessages[8]+"id.setLexemExclusionListFile:"+filename+";\n");
	}

	public static void pushLexemExclusionListFile(String filename){
		Translator translator= Translator.getCurrentTranslator();
		Stack stack= (Stack)translator.getValueFor(exclusionListStackPropertyKey);
		if (stack==null) {
			stack= new Stack();
			translator.setValueFor(exclusionListStackPropertyKey, stack);
		}
		stack.push(getLexemExclusionList(translator));
		setLexemExclusionListFile(filename);
		if (Base.LogLevel.get(10)) 
			OP.WrStr(Messages.systemMessages[7]+Messages.systemMessages[8]+"id.pushLexemExclusionList:"+filename+";\n");
	}

	public static void popLexemExclusionList(){
		Translator translator= Translator.getCurrentTranslator();
		Stack stack= (Stack)translator.getValueFor(exclusionListStackPropertyKey);
		if (stack==null) {
			return;
		}
		Object obj= stack.pop();
		if (obj!=null) {
			translator.setValueFor(exclusionListStackPropertyKey, obj);
		}
		if (Base.LogLevel.get(10)) 
			OP.WrStr(Messages.systemMessages[7]+Messages.systemMessages[8]+"id.popLexemExclusionList\n");
	}

}
