import Dp4.ModLoader;

/** Depot4 (c) J. Lampe 1996-2010
    Dp4Run.java
		
		Standalone runner for Depot4 generated translators

		Use:  java -classpath="..." Dp4Run <root> <sourceFile> <targetFile>
		  classpath must contain the Dp4Vxxx.jar and generated classes at least
    
	* @author	Juergen Lampe
	* @version 1.9.4
	* $Date:$
  */


public class Dp4Run {

	public static void main(String [] args){
	  if (args.length<3){             //#1
			System.out.println("Use:  Dp4Run <root> <infile> <outfile>");
			return;
	  }         

	  // set configuration (may be changed or omitted)
	  Dp4.config.read("Dp4Run.cfg");
  	  
	  // add your package to the search path, if generated with package directive (*!package='de.example.gen' *)
	  //ModLoader.addPackage("de.example.gen");

	  //Dp4.Translator translator= Dp4.Translator.createTranslator();	// create an own Translator

	  // call translator
	  Dp4.trgts tt= Dp4.Tools.translate(
			  //translator,									// use an own Translator here if possibly applied
			                                                // in different threads
			  Dp4.Files.IFile(args[1]),		       /*#2*/   // construct source object
			  args[0]	  						  /*#3*/    // root production name
	  );

	  // log result on stdout
	  if (Dp4.Tools.isOk(/*translator*/)) 		// take the Translator as argument, if used
		  System.out.println(" OK");
	  else 
		  System.out.println(" ERROR(S)");

	  if (Dp4.Tools.isOk(/*translator*/)) { 	// take the Translator as argument, if used
		  // if successful write target on file
		  Dp4.StreamTrg.Tar2Strm(tt.trg1, new Dp4.FileTrg(args[2])); //#4
	  }
	}
}

/**
Use:  Dp4Run <root> <infile> <outfile>

Can be changed to be called '<name> <infile> <outfile>' by:
(1) Rename Dp4Run to <name> and this source file to <name>.java
(2) Replace args[0] by "<root>" (!String) (#3)
(3) Replace args[1] by args[0] (#2) and args[2] by args[1] (#4)
(4) Change 3 to 2 (#1)
(5) Compile <name>.java

*/
