/** Depot4 for Java (c) J. Lampe 1997-2003
*/
package Dp4x;

import java.util.List;

/* The interface that every AST node must implement at least.
 * 
 * @author: Juergen Lampe
 * @version 1.9.2
 * Date: 17.03.2003
 */

public interface ASTNode {

	/** Returns the name of the nonterminal */
	public String getName();

	/** Adds an ASTNode as child node */
	public void addChild(ASTNode child);

	/** Retruns whether this node has children */
	public boolean hasChildren();

	/** Returns the children of this node */
	public List getChildren();

}
