/** Depot4 (c) J. Lampe 1997-2003
Check.java

		Implements a monitoring class which checks against unbounded
		recursion (mostly resulting from left recursive definitions).
		
    @author  Juergen Lampe
    @version 1.9.3
    Date: 17.06.2003
    */

package Dp4x;

import Dp4.*;

public class Check extends Dp4.NTprocMonT {
  protected static int MaxL= 200;
  int CallLevel= 0;
   
//--------------------------- checkLevel ------------------------
  public Dp4.trgts parse(NonTermT t, Prs p){
    trgts h;
    CallLevel++;
    if (CallLevel>MaxL) {
      OP.WrStr("*** check: recursion depth >"+MaxL+" ("+
        ((Dp4.NonTerm)t).name+")\n");
      p.A= false; 
			return new trgts();
		}
    h= super.parse(t, p);
    CallLevel--;
    return h;
  }
//-------------------------- clear ----------------------------
	public void clear() {
		CallLevel= 0;
	}

//-------------------------- setMax ----------------------------
  public static void setMax(int m){ 
		MaxL= m;
	}
}
