/** Depot4 IDE (c) J. Lampe 1999-2010
 *
 * This is a simple demo for AST building. It builds the AST and, afterwards,
 * performs a depth-first visit of the tree, the trace is printed to the log.
 *
 * This class can be added in the IDE as an UseCard.
 *
 * @author  Juergen Lampe
 * @version 1.3.4
 * $Date:$
 */

package Dp4.ide;

import java.util.List;

import Dp4.NTprocMonT;
import Dp4.OP;
import Dp4x.ASTBuilder;
import Dp4x.ASTNode;

public class AST extends UsePanel{

	private static final long serialVersionUID= 134788386144510153L;

	protected ASTBuilder ast= new ASTBuilder();
	
	public void run(){
		ast.clear();
		NTprocMonT.set(getTranslator(), ast);
		super.run();
		ASTNode astRoot = ast.getASTRoot();
		if (astRoot!=null)
			printAST(astRoot, 0);
	}

	public AST(){
		id= "AST";
	}

	private static final String empty= ".............................................................";
	public void printAST(ASTNode astNode, final int k){
		OP.WrStr(empty.substring(0, k)+astNode.getName()+"\n");
		if (astNode.hasChildren()){
			List children= astNode.getChildren();
			for (int i = 0; i<children.size(); i++) {
				ASTNode node = (ASTNode)children.get(i);
				printAST(node, k+1);
			}
		}

	}
}