/** Depot4 IDE (c) J. Lampe 1999-20013
 *
 * This is a simple demo for AST building. It builds the AST and, afterwards,
 * converts the tree into XML notation.
 *
 * This class can be added in the IDE as an UseCard.
 *
 * @author  Juergen Lampe
 * @version 1.3.4
 * $Date:$
 */

package Dp4.ide;

import java.util.List;

import Dp4.OP;
import Dp4x.ASTDefaultNode;
import Dp4x.ASTNode;

public class ASTXML extends AST{

	private static final long serialVersionUID= 7891157747551854176L;

	public ASTXML(){
		id= "ASTXML";
	}

	private static final String empty= "                                                    ";

	public void printAST(ASTNode astNode, final int k){
		final boolean isLeaf = !astNode.hasChildren();
		final String name = astNode.getName();
		OP.WrStr(empty.substring(0, k)+"<"+name);
		if (isLeaf){
			OP.WrStr(" value=\""+((ASTDefaultNode)astNode).getTargets().trg0+"\"></"+name);
		}
		OP.WrStr(">\n");
		if (!isLeaf){
			List children= astNode.getChildren();
			for (int i = 0; i<children.size(); i++) {
				ASTNode node = (ASTNode)children.get(i);
				printAST(node, k+1);
			}
			OP.WrStr(empty.substring(0, k)+"</"+name+">\n");
		}
	}
}