/** Depot4 IDE (c) J. Lampe 1999-2003
 * @author Juergen Lampe
 * @version 1.3.3
 */
package Dp4.ide;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.*;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

public class DebugBPDefFrame extends JFrame implements ActionListener, ListSelectionListener{
  protected Debug debugWindow;
  JButton closeButton= new JButton("Close"), rm= new JButton("Remove"),
    addButton= new JButton("Add/Modify"), RS= new JButton("RESET"),
    rma= new JButton("RemoveAll");
  JTextField tnt= new JTextField(12),
    tnr= new JTextField(" 1");
  DefaultListModel bplm= new DefaultListModel();
  JList bpl= new JList(bplm);
  JCheckBox inx= new JCheckBox("on entry", null, true),
           outx= new JCheckBox("on exit");
  Dimension ScS= Toolkit.getDefaultToolkit().getScreenSize();

	private JFrame restoreFrame;

	public void actionPerformed(ActionEvent evt){
	  boolean dd= false; 
	  int i, k, n= 0;
	  if (evt.getSource()==closeButton) 
	  		setVisible(false);
	  else if (evt.getSource()==addButton) {
			dd= false;
			dd= bplm.contains(tnt.getText());
			if (!dd) bplm.addElement(tnt.getText());
			//bpl.repaint();
			i= 0; String g= tnr.getText(); k= g.length();
			while(k>i&&!Character.isDigit(g.charAt(i))) i++;
			k= g.indexOf(" ",i); 
			k= (k>=i)?k:g.length();
			n= Integer.parseInt(g.substring(i, k));
			if (!(inx.isSelected()||outx.isSelected()))
				JOptionPane.showMessageDialog(this,
					 "Selecting whether 'on entry' nor 'on exit'\n will inactivate this breakpoint!",
					 "Warning", JOptionPane.WARNING_MESSAGE);
			if (n>0);
				debugWindow.add(tnt.getText(), inx.isSelected(), outx.isSelected(), n);
			bpl.clearSelection();
			tnt.setText("");
			tnt.requestFocus();
	  }else if (evt.getSource()==RS) { 
	  		debugWindow.reset();
	  }else if (evt.getSource()==rm&&bpl.getSelectedValue()!=null) {
	      i= bpl.getSelectedIndex(); 
	      bpl.clearSelection();
	      debugWindow.rm((String)bpl.getModel().getElementAt(i));
	      bplm.remove(i); 
	      //bpl.repaint();
	  }else if (evt.getSource()==rma) { debugWindow.rmAll();
	  		bplm.clear();
	    //bpl.validate();
	  } 
	}
	
	public void valueChanged(ListSelectionEvent e){
		int idx= bpl.getAnchorSelectionIndex();
		if (idx==-1)
			return;
		String nt= (String)bplm.getElementAt(idx);
		tnt.setText(nt);
		tnr.setText(""+debugWindow.getBPCount(nt));
		inx.setSelected(debugWindow.getOnEntry(nt));
		outx.setSelected(debugWindow.getOnExit(nt));
	}

	/**
	 * Shows or hides this component depending on the value of parameter
	 * <code>b</code>.
	 * @param b  If <code>true</code>, shows this component;
	 * otherwise, hides this component.
	 * @see #isVisible
	 * @since JDK1.1
	 */
	public void setVisible(boolean b) {
		if (b) {
			if (debugWindow.breakpointFrame.isVisible()) {
				restoreFrame= debugWindow.breakpointFrame;
			} else {
				restoreFrame= null;
			}
		}
		super.setVisible(b);
		if (!b && restoreFrame!=null) {
			restoreFrame.toFront();
			restoreFrame= null;
		}
	}

	public DebugBPDefFrame(String s, Debug uw){
    super(s);
    this.debugWindow= uw;
    bpl.addListSelectionListener(this);
	  JPanel bps= new JPanel(), mP= new JPanel(),
	    bps21= new JPanel(), bps22= new JPanel(),
	    bps23= new JPanel(), bps3= new JPanel();
    getContentPane().add(mP);
    mP.setLayout(new BorderLayout());
    bps.setLayout(new BoxLayout(bps, BoxLayout.X_AXIS));
    JLabel du= new JLabel("wwwwwwwwwwwwwww");
    Dimension dim= du.getPreferredSize();
    JScrollPane sp= new JScrollPane(bpl);
    sp.setPreferredSize(new Dimension(dim.width, dim.height*8));
    bps.add(sp);
    bps22.setLayout(new FlowLayout(FlowLayout.LEFT));
    bps22.add(new Label("on", Label.RIGHT));
    bps22.add(tnr);
    bps22.add(new Label("th invocation", Label.LEFT));
    bps21.setLayout(new BoxLayout(bps21, BoxLayout.Y_AXIS));
    bps21.add(new JLabel("Stop at "));
    tnt.setAlignmentX(Component.LEFT_ALIGNMENT);
    tnt.setPreferredSize(dim);
    tnt.setMaximumSize(dim);
    bps21.add(tnt);
    inx.setAlignmentX(Component.LEFT_ALIGNMENT);
    bps21.add(inx);
    outx.setAlignmentX(Component.LEFT_ALIGNMENT);
    bps21.add(outx);
    bps22.setAlignmentX(Component.LEFT_ALIGNMENT);
    bps21.add(bps22);
    bps21.add(Box.createVerticalGlue());
    bps23.setLayout(new GridLayout(3, 1));
    bps23.add(addButton);
    bps23.add(rm);
    bps23.add(rma);
    bps23.setBorder(BorderFactory.createEmptyBorder(10,5,10,5));
    bps.setBorder(BorderFactory.createLineBorder(Color.black));
    bps.add(bps23);
    bps.add(bps21);
    mP.add("North", new Label("Breakpoint definitions", Label.LEFT));
    mP.add("Center", bps);
    bps3.setLayout(new FlowLayout(FlowLayout.CENTER));
    bps3.add(closeButton);
    mP.add("South", bps3);
    pack();
//    int h3= ScS.height/3, w3= ScS.width/2;
//    setLocation(w3-20, 2*h3);
		Rectangle rect= MainData.getIt().curApp.getBounds();
		dim= getPreferredSize();
		if (rect.width==0)
			rect= new Rectangle(0, 0, ScS.width, ScS.height);
		setLocation(rect.x+(rect.width-dim.width)/2, rect.y+(rect.height-dim.height)/2);
		closeButton.addActionListener(this);
		rm.addActionListener(this);
		addButton.addActionListener(this);
		RS.addActionListener(this);
		rma.addActionListener(this);

  }
}