/** Depot4 IDE (c) J. Lampe 1999-2010
    IdeTools.java

		Extends Dp4.Tools for notifying other translators of module unloading.

		 @author  Juergen Lampe
		 @version 1.3.4
		 $Date:$
    */
    
package Dp4.ide;

import java.util.Vector;

import Dp4.Messages;
import Dp4.Tools;
import Dp4.ToolsFactory;
import Dp4.Translator;


public class IdeTools extends Tools{

	protected static Vector unloadListeners= new Vector();
	
	public static void addUnloadListener(Translator t) {
		unloadListeners.add(t);
	}

	public static void removeUnloadListener(Translator t) {
		unloadListeners.remove(t);
	}
	
	protected void fireUnload(String a) {
		for (int i= 0; i<unloadListeners.size(); i++) {
			try {
				((Translator)unloadListeners.get(i)).resetNT(a);
			} catch (Exception e) {
				Tools.logException(e, Messages.systemMessages[14]+e);
			}
		}
	}

	/** Overwrite (enhance) superclass method */
  public void unload(String a) {
		super.unload(a);
		fireUnload(a);
	}
  
	static{
		ToolsFactory factory= new ToolsFactory() {
			public Tools createToolsInstance(){
				return new IdeTools();
			}
		};
		Tools.setToolsFactory(factory);
	}

}