/** Depot4 IDE (c) J. Lampe 1999-2003
 *
 *
 * @author  Juergen Lampe
 * @version 1.3.3
 * date:   17.03.2003
 */

package Dp4.ide;

import java.awt.*;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import javax.swing.*;

public class Main extends JApplet implements WindowListener{

  private Container appContainer;
	private IdeMain ideMain;

	public static JApplet getThisApp() {
      return MainData.getIt().curApp;
  }

  public Main() {
  		MainData.getIt().init();
  		MainData.getIt().contentPane= this.getContentPane();
  		MainData.getIt().curApp= this;
  		
  		MainData.getIt().menubar= new JMenuBar();
		if (MainData.getIt().isStandalone)
			((JFrame)MainData.getIt().frame).setJMenuBar(MainData.getIt().menubar);
		else
			MainData.getIt().getThisApp().setJMenuBar(MainData.getIt().menubar);
  }

  public void init() {
		ideMain = new IdeMain();
		appContainer= ideMain.getMainPanel();
		MainData.getIt().contentPane.add(appContainer);
  }
  
  public void start() {
		MainData.getIt().startChildFrames();
  }
  
  public void stop() {
		MainData.getIt().stopChildFrames();
  }

  public void destroy() {
		MainData.getIt().disposeChildFrames();
  }

  public String getAppletInfo() {
    return MainData.getIt().Title+MainData.getIt().IdeVersion+"\nby "+MainData.getIt().Author;
  }

  public static void main(String[] args) {
  		JFrame frame= new JFrame();
		MainData.getIt().frame= frame;
		MainData.getIt().isStandalone= true;
		MainData.getIt().curApp= new Main();
		frame.setTitle(MainData.getIt().Title+MainData.getIt().IdeVersion);
		MainData.getIt().contentPane= frame.getContentPane();
		MainData.getIt().contentPane.add(MainData.getIt().curApp, BorderLayout.CENTER);
		MainData.getIt().curApp.init();
		MainData.getIt().curApp.start();
//		frame.pack();
		Dimension d = Toolkit.getDefaultToolkit().getScreenSize();
		MainData.getIt().frame.setSize(d.width-20, d.height-60);
		MainData.getIt().frame.setLocation(10, 10);
		frame.addWindowListener((Main)MainData.getIt().curApp);
		frame.setDefaultCloseOperation(WindowConstants.DO_NOTHING_ON_CLOSE);
		frame.setVisible(true);
		((Main)MainData.getIt().curApp).appContainer.setVisible(true);
  }

    /** Implement the WindowListener interface. */
    public void windowOpened(WindowEvent e) {}
    public void windowClosing(final WindowEvent e) {
      if (MainData.getIt().isStandalone){
				if (ideMain.checkAllSaved()){
        	System.exit(0);
				}
			} else
         stop();
    }
    public void windowClosed(WindowEvent e) {}
    public void windowIconified(WindowEvent e) {}
    public void windowDeiconified(WindowEvent e) {}
    public void windowActivated(WindowEvent e) {}
    public void windowDeactivated(WindowEvent e) {}
}