/** Depot4 IDE (c) J. Lampe 1999-2010

		An extension of Dp4.OP to redirect output into a TextArea.

    * @author  Juergen Lampe
    * @version 1.3.4
    * $Date:$
    */
    
package Dp4.ide;

import java.awt.Component;
import java.awt.FontMetrics;
import java.awt.Point;

import javax.swing.JTextArea;
import javax.swing.JViewport;
import javax.swing.text.BadLocationException;

import Dp4.OP;

public class OPTextArea extends OP{

  protected JTextArea textArea= null;
	protected int lineCount= 0, linePosition= 0;

	public OPTextArea(JTextArea ta) {
		textArea= ta;
	}
	public void wrStr(String arg){
		appendText(arg);
	}
	public void wrInt(int n){
		appendText(String.valueOf(n));
	}
	public void wrLn() {
		appendText("\n");
	}
	public void wrBt(byte [] argv){
		String.valueOf(argv);
	}
	public void wrChr(char c) {
		appendText(String.valueOf(c));
	}
	public void error(int i){
		appendText(" error:"+i+" \n");
	}
	public void warning(int i){
		appendText(" warn:"+i);
	}
	
	private void appendText(final String text) {
		textArea.append(text);
		try {
			lineCount= textArea.getLineOfOffset(textArea.getText().length());
		} catch (BadLocationException e) {
			lineCount= 0;
		}
		if (lineCount-linePosition>4) {
			Component parent= textArea.getParent();
			if (parent instanceof JViewport) {
				JViewport viewport= (JViewport)parent;
				FontMetrics metrics= textArea.getFontMetrics(textArea.getFont());
				int lineH= metrics.getHeight();
				int line = lineCount>7?lineCount-4:0;
				viewport.setViewPosition(viewport.toViewCoordinates(new Point(0, (line)*lineH)));
			}
			linePosition= lineCount;
		}
	}

}