/** Depot4 IDE (c) J. Lampe 1999-2003
    TranslateFilesPanel.java

    * @author  Juergen Lampe
    * @version 1.3.3
    * Date:   7.3.2001
    */
    
package Dp4.ide;

import java.awt.BorderLayout;
import java.awt.Cursor;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.io.File;
import java.io.IOException;
import javax.swing.JButton;
import javax.swing.JFileChooser;
import javax.swing.JPanel;

import Dp4.OP;

public class TranslateFilesPanel extends TranslatePanel implements ActionListener{

	private static final long serialVersionUID= -3598627789438014746L;

	private static int count= 0;

	JButton addB= new JButton("Add File(s)");
	JFileChooser chooser;
	File cd;

	public TranslateFilesPanel() {
		transRoot= "Dp4IfTrans";
		addB.addActionListener(this);
		addB.setEnabled(MainData.getIt().isStandalone);
		JPanel p= new JPanel(new FlowLayout(FlowLayout.LEFT));
		p.add(addB);
		add(p, BorderLayout.NORTH);
		tip= "Translate a list of Ml4 source files at once";
	}
	
	private static Cursor waitCursor= new Cursor(Cursor.WAIT_CURSOR);
	private JFileChooser getChooser() {
		String [] txts= {"txt", "Text"};
		if (chooser==null) {
			String dir= null;
			try {
				dir= System.getProperty("user.dir");
				cd= new File(dir);
			} catch (Exception e) {}
			chooser= new JFileChooser(dir);
			chooser.addChoosableFileFilter(new IdeFileFilter("java", "Java source files"));
			chooser.addChoosableFileFilter(new IdeFileFilter(txts, "text files"));
			chooser.addChoosableFileFilter(new IdeFileFilter("ml4", "Ml4 source files"));
			chooser.setApproveButtonText("Select");
			chooser.setMultiSelectionEnabled(true);
		} else
			chooser.setCurrentDirectory(cd);
		return chooser;
	}

	protected String getInstanceName() {
		if (count++>0)
			return "Translate Files "+count;
		else
			return "Translate Files";

	}

	public void open() {
		MainData.getIt().frame.setCursor(waitCursor);
		if(getChooser().showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
			cd= chooser.getCurrentDirectory();
			File[] files;
			if (System.getProperty("java.version").startsWith("1.2")){
					files= new File[]{chooser.getSelectedFile()}; // error in JDK 1.2.2
			}else {
					files = chooser.getSelectedFiles();
			}
			for (int i= 0; i<files.length; i++) {
				try {
					src.ta.append(files[i].getCanonicalPath()+"\n");
					//System.out.println("# "+files[i].getCanonicalPath());
				} catch (IOException ie) {
					OP.WrStr("** I/O Error: "+ie);
				}
			}
		}
		MainData.getIt().frame.setCursor(Cursor.getDefaultCursor());
	}
	

	public void actionPerformed(ActionEvent evt){
	  if (evt.getSource()==addB) {
	    open();
	  }
	}
	
  public void run(){
    getTranslator().pushNT("Dp4IfTrans", "Dp4.ide.Dp4IfTrans");
    super.run();
    getTranslator().popNT("Dp4IfTrans");
  }
}