/** Depot4 IDE (c) J. Lampe 1999-2003
    TranslatePanel.java

    * @author  Juergen Lampe
    * @version 1.3.3
    * Date:   27.02.2003
		* @since JDK 1.2
    */
    
package Dp4.ide;

import java.awt.BorderLayout;
import java.util.Date;

import Dp4.Base;
import Dp4.NTprocMonT;
import Dp4.OP;
import Dp4.Tools;
import Dp4.Translator;

public class TranslatePanel extends AbstractApplicationPanel{
	
	private static final long serialVersionUID= -3943838089721025928L;

	private static final boolean isTimed= true;
	private static int count= 0;

	protected String transRoot= "Ml4jTrans";
  
	public TranslatePanel() {
	  tip= "Implement a translator";
	  isUseWin= false;
	  setLayout(new BorderLayout());
	  src= new TextDisplayElement(0, "  Source: ");
	  add(src, BorderLayout.CENTER);
	  if (!MainData.getIt().isStandalone) {
		  src.ta.setText(
	         "\n\n\n          Translate in Applet not available."
	        +"\n\n\n          Full JDK (with compiler) and access to local file system needed.");
      }
	}

	protected String getInstanceName() {
		if (count++>0)
			return "Translate "+count;
		else
			return "Translate";
	}

	public Translator getTranslator() {
		return MainData.getIt().getMl4Translator();
	}
	
  public void run(){
	  Date date;
	  long time= 0;
	  updateData();
	  final Translator translator= getTranslator();
	  boolean sv= translator.isCap();
	  if (!MainData.getIt().isStandalone) return;  // is applet
	  NTprocMonT.setNo(translator);
	  if (isTimed) {
		  date= new Date();
		  time= date.getTime(); 
	  }
	  Base.LogLevel.xor(Base.LogLevel);
	  if (isWarnings) {
		  Base.LogLevel.set(6);
	  }
	  if (isVerboseCompiling) {
		  Base.LogLevel.set(9);
	  }

	  translator.setCap(true);
	  Tools.translate(translator, src.getSrc(isSelectionOnly),  translator.registNT(transRoot));
	  NTprocMonT.set(translator);
	  translator.setCap(sv);
	  if (isTimed) {
		  date= new Date();
		  time= date.getTime()-time;
		  OP.WrStr(""+((int)time/1000)+"."+((int)time%1000)+" sec.\n");
	  }
	  updateMenu();
  }
  
  void updateMenu() {
		super.updateMenu();
		MainData.getIt().menubar.getMenu(MainData.OPTIONS_MENU).setEnabled(true);
		MainData.getIt().menubar.getMenu(MainData.TRANSLATE_MENU).setEnabled(true);
	}
	
  void updateData() {
		super.updateData();
		MainData.getIt().menubar.getMenu(MainData.OPTIONS_MENU).setEnabled(false);
		MainData.getIt().menubar.getMenu(MainData.TRANSLATE_MENU).setEnabled(false);
  }

	public boolean isChanged() {
		return src.isChanged();
	}
}